<?php 
/**
 * Система управления сайтом HostCMS v. 5.xx
 * Copyright © 2005-2008 ООО "Хостмэйк" (Hostmake LLC), http://www.hostcms.ru
 *
 * Ajax загрузчик списка меню сайта.
 * 
 * Файл: /admin/structure/action/load_menu.php
 * 
 * @author Hostmake LLC
 * @version 5.2
 */
function LoadAjaxData(&$admin_forms)
{
	$on_page = $admin_forms->GetOnPageCount();

	$page = to_int($_REQUEST['limit']);
	$begin = ($page == 0) ? 0 : ($page - 1) * $on_page;

	$structure = & singleton('Structure');

	$param = array();

	$param['limit'][0] = array('begin' => $begin, 'count' => $on_page);

	$structure_parent_id = to_int($_REQUEST['structure_parent_id']);

	// Строим "хлебные крошки"
	$struct = & singleton('Structure');

	$path_array = $struct->GetStructurePathArray($structure_parent_id, false);

	// Массив "хлебных крошек"
	$new_path_array = array();

	$new_path_array[0]['name'] = $GLOBALS['MSG_structure']['parent_dir'];
	$new_path_array[0]['link'] = $admin_forms->GetHtmlCallDoLoadAjax('/admin/structure/structure.php', "&action=show&structure_parent_id=0", 82, 'load_data');
	$new_path_array[0]['onclick'] = $admin_forms->GetOnClickCallDoLoadAjax('/admin/structure/structure.php', "&action=show&structure_parent_id=0", 82, 'load_data');

	$new_path_array[1]['name'] = $GLOBALS['MSG_structure']['menu_item_site'];
	$new_path_array[1]['link'] = $admin_forms->GetHtmlCallDoLoadAjax('/admin/structure/structure.php', "&structure_parent_id={$structure_parent_id}", 87, 'load_data');
	$new_path_array[1]['onclick'] = $admin_forms->GetOnClickCallDoLoadAjax('/admin/structure/structure.php', "&structure_parent_id={$structure_parent_id}", 87, 'load_data');

	$param['path_array'] = $new_path_array;

	$site_id = CURRENT_SITE;

	// Выборка нужных записей.
	$param['data'][] = "SELECT * FROM `menu_table` WHERE `site_id` = '$site_id'	{FILTER_STRING} {ORDER_STRING} {LIMIT}";

	// Число нужных записей.
	$count = "SELECT count(*) AS count FROM `menu_table` WHERE `site_id` = '$site_id'	{FILTER_STRING}";

	// Формируем верхнее меню.
	$k = 0;
	$menu = array();
	$menu[$k]['name'] = $GLOBALS['MSG_structure']['menu_item_site_m'];
	$menu[$k]['link'] = '';
	$menu[$k]['icon'] = '';

	$p = 0;

	// Формируем подэлементы.
	$sub_menu = array();
	$sub_menu[$p]['name'] = $GLOBALS['MSG_structure']['menu_item_site_m_add'];
	$sub_menu[$p]['link'] = $admin_forms->GetHtmlCallTrigerSingleAction('edit_menu', 'check_0_0', 87, 0, 0);
	$sub_menu[$p]['onclick'] = $admin_forms->GetOnClickCallTrigerSingleAction('edit_menu', 'check_0_0', 87, 0, 0);
	$sub_menu[$p]['icon'] = '/admin/images/menu_add.gif';

	// Добавляем подэлементы.
	$menu[$k]['sub_items'] = $sub_menu;

	// Формируем массив меню.
	$menu_array = array();
	$menu_array[] = $menu;

	$param['total_count'][] = $count;
	$param['current_page'] = $page;
	$param['on_page'] = $on_page;
	$param['menus'] = $menu_array;
	$param['title'] = $GLOBALS['MSG_structure']['menu_item_site'];

	return $param;
}

// Обработчик удаления меню
function delete_menu(&$param)
{
	ob_start();

	if (defined('READ_ONLY') && READ_ONLY)
	{
		$kernel = & singleton('kernel');

		$kernel->ReadMode();
	}
	else
	{
		$menu = new menu();

		$count = 0;

		if (isset($param['data']))
		{
			foreach ($param['data'] as $dataset)
			{
				foreach ($dataset as $key => $value)
				{
					// Определяем режим доступа пользователя и принадлежит ли объект пользователю
					$user_access = new user_access();

					$menu = & singleton('menu');

					// Определяем информацию об объекте
					$object_row = $menu->SelectMenu($key);

					if ($object_row)
					{
						$object_user_id = $object_row['users_id'];
					}
					else
					{
						$object_user_id = 0;
					}

					if ($user_access->IssetUserAccessForObject($object_user_id))
					{
						if (!$menu->DeleteMenu($key))
						{
							$flag_success = false;
						}
						else
						{
							$count++;

							$flag_success = true;
						}
					}
					else
					{
						$user_access->MessageOnlyOwn();

						$flag_success = false;
					}
				}
			}

			if ($flag_success)
			{
				if ($count == 1)
				{
					show_message($GLOBALS['MSG_menu']['menu_delete_message']);
				}
				else
				{
					show_message($GLOBALS['MSG_menu']['menus_delete_message']);
				}
			}
		}
	}

	$error = ob_get_clean();

	$param['error'] = $error;
}

// Обработчик добавления/редактирования меню
function edit_menu(&$param)
{
	ob_start();

	$structure_parent_id = to_int($_REQUEST['structure_parent_id']);

	if (isset($param['data']))
	{
		if (isset($param['data'][0]))
		{
			$menu_id = 0;

			foreach ($param['data'][0] as $menu_id => $value)
			{
				// Определяем режим доступа пользователя и принадлежит ли объект пользователю
				$user_access = new user_access();

				$menu = & singleton('menu');

				// Определяем информацию об объекте
				$object_row = $menu->SelectMenu($menu_id);

				if ($object_row)
				{
					$object_user_id = $object_row['users_id'];
				}
				else
				{
					$object_user_id = 0;
				}

				if ($user_access->IssetUserAccessForObject($object_user_id))
				{
					include(CMS_FOLDER.'admin/structure/action/form_edit_add_menu.php');

					// Устанавливаем <title> для страницы
					$param['title'] = ($menu_id == 0) ? $GLOBALS['MSG_menu']['menu_add_title'] : $GLOBALS['MSG_menu']['menu_edit_title'];

					break;
				}
				else
				{
					$user_access->MessageOnlyOwn();
					$param['error'] = ob_get_clean();
					return ;
				}
			}

		}
	}

	$param['result'] = ob_get_clean();


	return true;
}

// Применить изменения
function apply_change(&$param)
{
	ob_start();

	if (defined('READ_ONLY') && READ_ONLY)
	{
		$kernel = & singleton('kernel');

		$kernel->ReadMode();
	}
	else
	{
		$params = array();

		$DataBase = & singleton('DataBase');

		if (isset($param['data']))
		{
			if (isset($param['data'][0]))
			{
				foreach ($param['data'][0] as $key => $value)
				{
					// Определяем режим доступа пользователя и принадлежит ли объект пользователю
					$user_access = new user_access();

					$menu = & singleton('menu');

					// Определяем информацию об объекте
					$object_row = $menu->SelectMenu($key);

					if ($object_row)
					{
						$object_user_id = $object_row['users_id'];
					}
					else
					{
						$object_user_id = 0;
					}

					if ($user_access->IssetUserAccessForObject($object_user_id))
					{
						$val = to_int($value['menu_order']);

						$query = "UPDATE `menu_table` SET `menu_order` = '$val' WHERE `menu_id` = '$key'";

						$DataBase->query($query);
					}
					else
					{
						$user_access->MessageOnlyOwn();
						$param['error'] = ob_get_clean();
						return ;
					}
				}
			}
		}
	}

	$error = ob_get_clean();

	$param['error'] = $error;
}

// Копировать
function copy_menu (&$param)
{
	ob_start();

	if (defined('READ_ONLY') && READ_ONLY)
	{
		$kernel = & singleton('kernel');

		$kernel->ReadMode();
	}
	else
	{
		$menu = new menu();

		$count = 0;

		if (isset($param['data']))
		{
			foreach ($param['data'] as $dataset)
			{
				foreach ($dataset as $key => $value)
				{
					// Определяем режим доступа пользователя и принадлежит ли объект пользователю
					$user_access = new user_access();

					$menu = & singleton('menu');

					// Определяем информацию об объекте
					$object_row = $menu->SelectMenu($key);

					if ($object_row)
					{
						$object_user_id = $object_row['users_id'];
					}
					else
					{
						$object_user_id = 0;
					}

					if ($user_access->IssetUserAccessForObject($object_user_id))
					{
						if (!$menu->CopyMenu($key))
						{
							$flag_success = false;
						}
						else
						{
							$count++;

							$flag_success = true;
						}
					}
					else
					{
						$user_access->MessageOnlyOwn();

						$flag_success = false;
					}
				}
			}

			if ($flag_success)
			{
				show_message($GLOBALS['MSG_menu']['menu_copy_message']);
			}
			else
			{
				show_error_message($GLOBALS['MSG_menu']['menu_copy_error_message']);
			}
		}
	}

	$error = ob_get_clean();

	$param['error'] = $error;
}
?>